Channels (Java SE 26 & JDK 26)
Description: declaration: module: jdk.net, package: jdk.nio, class: Channels
Keywords: jdk.nio.Channels class

# Class Channels

java.lang.Object
jdk.nio.Channels

public final class Channels extends Object
Defines static methods to create `channels`.

Unless otherwise specified, passing a `null` argument to any of the methods defined here will cause a `NullPointerException` to be thrown.

Since:
  11

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `Channels.SelectableChannelCloser`
  An object used to coordinate the closing of a selectable channel created by `readWriteSelectableChannel`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static SelectableChannel`
  `readWriteSelectableChannel(FileDescriptor fd, Channels.SelectableChannelCloser closer)`
  Creates a selectable channel to a file descriptor that supports an `operation-set` of `OP_READ` and `OP_WRITE`.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Method Details

  - ### readWriteSelectableChannel

    public static SelectableChannel readWriteSelectableChannel(FileDescriptor fd, Channels.SelectableChannelCloser closer)
    Creates a selectable channel to a file descriptor that supports an `operation-set` of `OP_READ` and `OP_WRITE`. The selectable channel will be created by the default `SelectorProvider`.

    The given file descriptor is a socket or resource that can be multiplexed by a `Selector` for read and write readiness. Great care is required to coordinate direct use of the file descriptor with the use of the selectable channel. In particular, changing the blocking mode or closing the file descriptor without careful coordination will result in unspecified and unsafe side effects. The given `SelectableChannelCloser` is invoked to close the file descriptor and to coordinate the closing when the channel is registered with a `Selector`.

    Implementation Note:
      This method throws `UnsupportedOperationException` if the default `SelectorProvider` is not the JDK built-in implementation.
    Parameters:
      `fd` - The file descriptor
      `closer` - The object to close the channel
    Returns:
      The selectable channel
    Throws:
      `IllegalArgumentException` - If the file descriptor is not `valid`